<?php

namespace App\Http\Controllers\Admin\Structure;

use App\Http\Controllers\Controller;
use App\Http\Requests\HomeTextRequest;
use App\Models\HomeText;
use App\Traits\ApiResponser;
use Illuminate\Http\Request;

class HomeTextController extends Controller
{
    use ApiResponser;

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $home = HomeText::select('content', 'id')->get();
        return (isset($home)) ? $this->onSuccess($home) : $this->onFaile('Why proscreen pin not found');

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create(Request $request)
    {


//        HomeText::c
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(HomeTextRequest $request)
    {
        $home = array();
//        return $request;
        foreach ($request->validated()->content as $value) {
            $home[] = HomeText::create(['content' => $value]);
        }

        return (isset($home)) ? $this->onSuccess($home) : $this->onFaile('Why proscreen pin Could not save ');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(HomeTextRequest $request, $id)
    {
//        return $request->content;
        $home= HomeText::find($id);
        if ($home)
            $home= $home->update(['content' => $request->validated()->content]);
     return  ($home)?
       $this->onSuccess( HomeText::find($id)):$this->onFaile('Why proscreen pin Could not update ');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $HomeText = HomeText::find($id);
        return ($HomeText)
          ?  $this->onSuccess($HomeText->delete()):
         $this->onFaile('Why proscreen pin not found');
    }
}
