<?php

namespace App\Http\Controllers\Client;

use App\Http\Controllers\Controller;
use App\Http\Requests\User\ForgotPassword\ChangePasswordRequest;
use App\Http\Requests\User\ForgotPassword\ConfirmCodeRequest;
use App\Models\Company;
use App\Models\User;
use App\Repositories\Role\SearchRepository;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Cache;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;
use Symfony\Component\HttpFoundation\Response;

class ForgotPasswordController extends Controller
{
    public $request;

    public function __construct(Request $request)
    {
        $this->request = $request;
    }

    public function confirmCode(ConfirmCodeRequest $confirmCodeRequest, SearchRepository $searchRepository)
    {
        //check confirmation code
        $cacheCode = Cache::get($this->request['email']);
        if ($cacheCode == null || $cacheCode != $this->request['confirmation_code']) {
            return successResponse(false,null,'your code is incorrect');
        }

        $roles = [Company::class,User::class];
        foreach ($roles as $role) {
            $value = $searchRepository->searchEmail($role, $this->request['email']);
            if ($value != null){
                goto role;
            }
        }
        role:
        $class = get_class($value);
        $pos = strrpos($class, '\\');
        $role = $pos === false ? $class : substr($class, $pos + 1);


        //create token and put database
        $passwordToken = Str::random(52);
        DB::table('password_resets')->insert(['email' => $this->request['email'], 'token' => $passwordToken, 'created_at' => Carbon::now()->toDateTimeString()]);
        return successResponse(true, ['token' => $passwordToken, 'role' => $role], 'your code is correct',
            Response::HTTP_CREATED);
    }

    public function resetPassword(ChangePasswordRequest $changePasswordRequest, $clientRole)
    {
        $className = "\\App\\Models\\" . Str::ucfirst($clientRole);
        //check token exist
        $dbResult = DB::table('password_resets')->select('email')->where('token', $this->request['token'])->where('created_at', '>', Carbon::now()->subMinutes(60)->toDateTimeString())->get();
        if ($dbResult->toArray() == null) {
            return failedResponse('your token is invalid or expired!', Response::HTTP_UNAUTHORIZED);
        }

        //change password
        $setNewPass = $className::where('email', $dbResult[0]->email)->update(['password' => bcrypt($this->request['password'])]);
        if ($setNewPass == 0) {
            return failedResponse('your token not matched', Response::HTTP_UNAUTHORIZED);
        }
        return successResponse(true, null, 'your password changed');
    }

}
