<?php

namespace App\Http\Controllers;

use App\Http\Requests\CustomerRequest;
use App\Services\CustomerService;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class CustomerController extends Controller
{
    public $request;
    public $customerService;

    public function __construct(Request $request,CustomerService $customerService)
    {
        $this->request = $request;
        $this->customerService = $customerService;
    }

    public function add(CustomerRequest $customerRequest, $clientRole)
    {
        $client = auth($clientRole)->user();
        $customer = $this->customerService->add($customerRequest->validated(), $client);
        return successResponse(true, $customer, 'add successfully');
    }

    public function delete($clientRole, $id)
    {
        $client = auth($clientRole)->user();
        $customerExists = $this->customerService->checkExits($client, $id);

        if ($customerExists){
            $this->customerService->delete($id);
            return successResponse(true, null, 'delete successfully');
        }
        return failedResponse("not found any customer", Response::HTTP_NOT_FOUND);
    }
}
