<?php

namespace App\Http\Controllers;

use App\Filter\Title;
use App\Http\Requests\JobRequest;
use App\Http\Resources\ShowCommentResource;
use App\Http\Resources\ShowJobResource;
use App\Models\Job;
use App\Models\JobTitle;
use App\Models\Skill;
use App\Repositories\JobRepository;
use App\Repositories\JobTitleRepository;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use App\Traits\pipeline;
use Illuminate\Http\Request;
use Symfony\Component\HttpFoundation\Response;

class JobController extends Controller
{
    use ApiResponser,pipeline;
    public $request;
    public function __construct(Request $request)
    {
        $this->request = $request;
    }

    public function store($clientRole, JobRequest $jobRequest, JobRepository $jobRepository)
    {
        $client = auth($clientRole)->user();
//        return $jobRequest['skill'];

//        return $jobRequest;
        $jobId = null;
        if (array_key_exists('job', $jobRequest->validated())) {
            $jobTitleRepository = new JobTitleRepository();
            $job = $jobTitleRepository->findJob($jobRequest->validated()['job']);
            if ($job == null) {
                return failedResponse('Not Found job', Response::HTTP_NOT_FOUND);
            }
            $jobId = $job->toArray()['id'];
        }
        $datas=array();
//        return $data['skill'] ;
        foreach ($jobRequest['skill'] as $item){
            $datas[]= Skill::query()->create([
                'name'=>$item
            ])->id;
        }

        $data = $jobRepository->createJob($client, $jobRequest->validated(), $jobId,$datas);
//        return $data;
        return ($data)?$this->onSuccess(ShowJobResource::collection(collect($jobRepository->show()))):$this->onFaile('Nothing was registered');
//            successResponse(true,Job::find($data)->load('skill') , 'add successfully');
    }

    public function show(JobRepository $jobRepository)
    {
        $data = $jobRepository->show();
//        return ($data);
        return successResponse(true,ShowJobResource::collection(collect($data)), 'send successfully');
    }
   public function industry(){
       $job=  JobTitle::query()->select('title','id')->get();
     return  ($job)?$this->successResponseWithoutMessage(true,$job)
           :$this->successResponseWithoutMessage(true,[]);
   }
    public function industryPaginate(){
        $job= $this->pipeline( JobTitle::query()->select('title','id'),[Title::class]);
        return  ($job)?$this->successResponseWithoutMessage(true,$job)
            :$this->successResponseWithoutMessage(true,[]);
    }
    public function industryPhoto(){
        $job= JobTitle::select('title','id','photo')->get();
        return  ($job)?$this->successResponseWithoutMessage(true,$job)
            :$this->successResponseWithoutMessage(true,[]);
    }

}
