<?php

namespace App\Http\Controllers;

use App\Models\Admin\Structure\SiteInformation;
use App\Models\CountProject;
use App\Traits\ApiResponser;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class ReferralCodeController extends Controller
{
    use ApiResponser;

    public $request;
    public $clientType;
    public $clientEntity;
    public $clientEntityId;

    public function __construct(Request $request)
    {
        $this->request = $request;
    }

    public function show($clientRole)
    {
        $this->clientEntity = auth($clientRole)->user();
        $this->clientId = $this->clientEntity->id;
        $this->clientType = 'App\\Models\\' . Str::ucfirst($clientRole);

        $informationClient = $this->clientType::select('referral_code')
            ->where('id', $this->clientId)->first();
        //dd($informationUser->);
        $referralCode = $informationClient['referral_code'];
        $informationClient = CountProject::select('total_invited', 'remaining_invited')
            ->where('client_type', $this->clientType)->where('client_id', $this->clientId)->first();
//dd($informationClient);
        $totalInvitation = $informationClient['total_invited'];

        $information = SiteInformation::select('key', 'value')->where('type', 'referral_number')->get();
        $userNumber = 2;
        $projectNumber = 5;

        $div = intdiv($totalInvitation, $userNumber);
        $totalProjectCanAdd = $div * $projectNumber;
        return $this->successResponse(true, [
            'referral_code' => $referralCode,
            'free_project' => $projectNumber,
            'people' => $userNumber
        ],
            'send successfully');
    }


}
