<?php

namespace App\Http\Requests\User;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;

class UserRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {

        $user = auth()->user()->toArray();
        return [
            'first_name' => 'required|alpha|max:255|min:3',
            'last_name' => 'required|alpha|max:255|min:3',
            'email' => [
                'required',
                'email',
                Rule::unique('users', 'email')->ignore($user['id'])
            ],
            'image' => 'image|mimes:jpg,png,jpeg,gif,svg|max:2048',
            'phone_number' => 'numeric|max:20',
            'work_experience' => 'numeric|digits:4',
            'job_title' => 'alpha|max:30|min:3',
            'about_us' => 'max:600',
            'social_media.*' => 'min:3|max:200',
            /*'facebook' => 'min:3|max:100',
            'instagram' => 'min:3|max:100',
            'twitter' => 'min:3|max:100',
            'website' => 'min:3|max:100',
            'linkedin' => 'min:3|max:100',
            'yelp' => 'min:3|max:100',
            'houzz' => 'min:3|max:100',
            'thumbtack' => 'min:3|max:100',*/
        ];
    }
}
