<?php

namespace App\Http\Resources;

use App\Models\Company;
use App\Models\User;
use Illuminate\Http\Resources\Json\JsonResource;

class GetPrivateChatsMesssageResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {
//        return parent::toArray($request);
    if ($this->sender_type==User::class)
        $send='user';
        if ($this->sender_type==Company::class)
        $send='company';
        $sender=auth($send)->user();
        if ($sender)
            $is_sender=($sender->id==$this->sender_id);
        return [
            'id'=>$this->id,
            'uuid'=>$this->uuid,
            'message'=>$this->message,
            'name'=>$this->sender->name??"",
            'last_name'=>$this->sender->last_name??"",
            'image'=>$this->sender->image??"",
            'readed_at'=>$this->readed_at
            ,'is_sender'=>$is_sender??""
        ];
    }
}
