<?php

namespace App\Repositories;

use App\Models\Job;
use App\Models\Skill;
use App\Models\Skill_job;
use App\Models\SkillJob;
use App\Traits\ApiResponser;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;
use function Composer\Autoload\includeFile;

//use Your Model

/**
 * Class JobRepository.
 */
class JobRepository extends BaseRepository
{
    use ApiResponser;

    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return Job::class;
    }

    public function createJob($client, $data, $id,$datas)
    {

        $job = Job::query()->create([
            'client_type' => get_class($client),
            'client_id' => $client->id,
            'job_title_id' => $id,
            'experience' => $data['experience'],
            'description' => $data['description'],
//            'skill' => $data['skill'],
            'phone_number' => $data['phone_number'],
        ]);

//       return $datas;
        $job->skill()->sync($datas);
        return $job;
    }

    public function show()
    {
        return Job::query()->with('skill', 'job_title','client.rates','client.job_title')->orderBy('created_at', 'DESC')->get();
    }

    public function updateJob($request, $id)
    {
        $job = Job::find($id);
        if ($job) {
            if (isset($request['job_title_id']))
                $requestsTechnician['job_title_id'] = $request['job_title_id'];
            if (isset($request['experience']))
                $requestsTechnician['experience'] = $request['experience'];
            if (isset($request['description']))
                $requestsTechnician['description'] = $request['description'];
            if (isset($request['phone_number']))
                $requestsTechnician['phone_number'] = $request['phone_number'];
            $job->skill()->sync($request['skill']);
            return $job->update($requestsTechnician);
        } else {
            return false;
        }
    }

    public function deleteJob($id)
    {
        $job = Job::find($id);
//        return $job;

     return ($job)? $job->delete()??false:false;
//        ($jobs) ? $this->successResponseWithoutMessage(true, $job) : $this->failedResponse('not find job');

    }
}
