<?php

namespace App\Repositories;

use App\Models\User;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class ReferralCodeRepository.
 */
class ReferralCodeRepository extends BaseRepository
{
    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return USer::class;
    }

    public function searchCode($code, $type)
    {
        if (!is_array($type))
            return $type::where('referral_code', $code)->first();

        foreach ($type as $role) {
            $data = $role::where('referral_code', $code)->first();

            if (!!$data)
                return $data;
        }
        return null;
    }

    public function countCode($id, $type)
    {
        $totalInvited = $type::where('id', $id)->pluck('total_invitation');
        $totalInvited = $totalInvited->toArray()[0] + 1;
        return $type::where('id', $id)->update(['total_invitation' => $totalInvited]);
    }
}
