<?php

namespace App\Http\Controllers;

use App\Events\GroupEvent;
use App\Filter\FilterClass\Chat\Type;
use App\Http\Requests\AddMemberRequest;
use App\Http\Requests\CreateGroupRequest;
use App\Http\Requests\ListGroupRequest;
use App\Http\Requests\SendMessageRequests;
use App\Http\Resources\CreateGroupResource;
use App\Http\Resources\GetGroupChatsMesssageResource;
use App\Http\Resources\GetPrivateChatsResource;
use App\Http\Resources\ListGroupsResource;
use App\Http\Resources\PaginationResource;
use App\Http\Resources\ShowAllChatsResource;
use App\Models\Admin\Admin;
use App\Models\Company;
use App\Models\ParticipantsProject;
use App\Models\User;
use App\Services\ChatService;
use App\Services\GroupService;
use App\Traits\ApiResponser;
use App\Traits\Helper;
use App\Traits\pipeline;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Str;
use Mojtaba\Chatable\Models\Chat;
use Mojtaba\Chatable\Models\Group;
use Mojtaba\Chatable\Models\Member;
use PHPUnit\TextUI\XmlConfiguration\GroupCollection;

class ChatController extends Controller
{
    use Helper, ApiResponser, pipeline;

    public $clientType;
    public $clientEntity;
    public $clientId;
    public $client;

    public function index()
    {
//        dd(User::first()->hasChatWith(User::find(2)));

        /**
         * @var User $user
         */
        $user = User::query()->first();

        /**
         * @var Company $company
         */
        $company = Company::query()->where('id', 2)->first();

        //dump($user->chatWith($company));
        //$user->hasChat($company);
        //dd($company->hasChat(Chat::where('id', 5)->first()));

//    dump($message);
        $chat = Chat::where('sender_type', User::class)->where('sender_id', $user->id)->first();
        $m = ['message' => 'test chat private'];
        $message = $user->sendChatMessage($chat, $m);

        //$user->chats()->withUnreadMessagesCount()->get();

        //$user->markChatMessageAsRead($chat);
        return successResponse(true, $message, 'ok');
    }

    public function getGroup($clientRole)
    {

        $this->setInformation($clientRole);
        $clientEntity = auth($clientRole)->user();

        $groups['groups'] = $this->pipelineWithoutPaginate(
            Group::query()->whereHas('members', function ($q) {
            $q->where('member_id', $this->clientId)
                ->where('member_type', $this->clientType);
        }) ->withCount(["messages" => function ($q) use ($clientEntity) {
                $q->where(function ($q) use ($clientEntity) {
                    $q->where(function ($q) use ($clientEntity) {
                        $q->where('sender_id', '!=', $clientEntity->id)
                            ->orWhere('sender_type', '!=', get_class($clientEntity));
                    })->whereNull('readed_at');
                });
            }]), [Type::class]);

//        $groups['groups']=  ParticipantsProject::query()
//            ->with(['participantsProject'=>function($q){
//                $q->select('id','image')->take(4);
//            }])
//            ->select('participants_project_type','participants_project_id')->get();
        $groups['groups'] =  ListGroupsResource::collection($groups['groups']);
//        return $groups['groups'];
//        return $this->clientId;
//         $groups['listd']=ListGroupsResource::collection($group);
//        return get_class($clientEntity);
         $groups['chats']=Chat::query()
             ->with('sender','receiver')
//             ->where('receiver_id',$this->clientId)
//             ->where('receiver_type',$this->clientType)
             ->orwhere(function ($q) use ($clientEntity) {
                 $q->where('receiver_id', $this->clientId)
                     ->Where('receiver_type', $this->clientType);
             })
             ->orwhere(function ($q) use ($clientEntity) {
                 $q->where('sender_id', $this->clientId)
                     ->Where('sender_type', $this->clientType);
             })
//             ->where('sender_type',$this->clientType)
             ->withCount(["messages" => function ($q) use ($clientEntity) {
                 $q->where(function ($q) use ($clientEntity) {
                     $q->where(function ($q) use ($clientEntity) {
                         $q->where('sender_id', '!=', $clientEntity->id)
                             ->orWhere('sender_type', '!=', get_class($clientEntity));
                     })
                         ->whereNull('readed_at');
                 });
             }])
             ->where('sender_type',$this->clientType)->get();
        $groups['chats']=ShowAllChatsResource::collection($groups['chats']);
//        return  $groups['chats'];
//        return $groups;
        return (!isset($groups['chats'] )&& !isset($groups['groups'])) ?   $this->onSuccess([]):$this->onSuccess($groups);
    }

    public function sendGroupMessage($clientRole,SendMessageRequests $request,GroupService $serviceGroup)

    {
//        return 1;

        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $clientEntity = auth($clientRole)->user();
        $clientId = $clientEntity->id;

        $client = $clientType::find($clientId);
//        return $client;
        $receiverType = 'App\\Models\\' . Str::ucfirst($request->receiver_role);
        $receiverId = $request->receiver_id;
//        $receiver= $receiverType::find($receiverId);
//        return 1;
//        if (!$receiver)
//            return $this->onFaile('receiver not found');
        $chatable=Group::query()->where('uuid',$request->uuid)->first();

//        $chatable = $clientType::find($clientId)->hasChatWith($receiverType::find($receiverId));
        if (!$chatable) {
            return $this->onFaile('group no found ');
        }
//        if ()

        $message=   $serviceGroup->storeMessage($request,$clientId,$clientType,$chatable->id);
//       $client->sendChatMessage(Chat::find($chatable), [
//            'message' => $request->message??"",
//            'file' => $request->file
//        ]);
        event(new GroupEvent($message));


        //dd(Request()->receiver_role);
        return successResponse(true, $message, 'send successfully');
    }

    public function sendPriavteMessage($clientRole,SendMessageRequests $request)

    {
//        return 1;

        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $clientEntity = auth($clientRole)->user();
        $clientId = $clientEntity->id;

        $client = $clientType::find($clientId);
//        return $client;
        $receiverType = 'App\\Models\\' . Str::ucfirst($request->receiver_role);
        $receiverId = $request->receiver_id;
        $receiver= $receiverType::find($receiverId);
//        return 1;
        if (!$receiver)
            return $this->onFaile('receiver not found');

        $chatable = $clientType::find($clientId)->hasChatWith($receiverType::find($receiverId));
        if (!$chatable) {
            $chatable = $clientType::find($clientId)->chatWith($receiverType::find($receiverId))->id;
        }

        $message = $client->sendChatMessage(Chat::find($chatable), [
            'message' => $request->message??"",
            'file' => $request->file
        ]);
        //dd(Request()->receiver_role);
        return successResponse(true, $message, 'send successfully');
    }

    public function getPrivateMessages($clientRole)
    {
        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $clientEntity = auth($clientRole)->user();
        $clientId = $clientEntity->id;

        $client = $clientType::find($clientId);

        $chat = Chat::with('message')->where('id', 1)->first();

        dump($chat->message()->get());
    }

    public function getPrivateChats($clientRole,$uuid)
    {
        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $clientEntity = auth($clientRole)->user();
        $clientId = $clientEntity->id;
        $client = $clientType::where('id', $clientId)->first();
//        $chats = $client->chats()->withUnreadMessagesCount($client)->get();

        $chats = Chat::query()->where('uuid', $uuid)->with('messages.sender')->get();
        return successResponse(true, GetPrivateChatsResource::collection($chats), 'send message successfully');
    }
    public function getChatsGroup($clientRole,$uuid)
    {
        $clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $clientEntity = auth($clientRole)->user();
        $clientId = $clientEntity->id;
        $client = $clientType::where('id', $clientId)->first();

//        $chats = $client->chats()->withUnreadMessagesCount($client)->get();

        $chats = Group::query()->where('uuid', $uuid)->with('messages.sender')->get();
        return ($chats)?successResponse(true, GetGroupChatsMesssageResource::collection($chats), 'get message successfully'):$this->onSuccess([]);
    }
    public function createGroup($clientRole, CreateGroupRequest $request)
    {

//        return $request;
        $this->setInformation($clientRole);
        if (isset($request->member)) {
            foreach ($request->member as $key => $value) {
//                return  $value['id'];
                if ($this->clientId == $value['id'] && $this->clientType == 'App\\Models\\' . Str::ucfirst($value['type']))
                    return $this->onFaile('You can not add yourself as a user to the project');
            }
            if (!(('App\\Models\\' . Str::ucfirst($value['type']))::query()->where('id', $value['id'])->first()))
                return $this->onFaile('user not found');
        }

        $group = Group::create([
            'title' => $request->name,
            'type' => $request->type,
            'uuid' => (string)Str::uuid(),
//            'image' =>'a',
            'address' => $request->address,
            'subject' => $request->subject,
        ]);

        if ($group) {
            $member = Member::create([
                'group_id' => $group->id,
                'member_id' => $this->clientId,
                'uuid' => (string)Str::uuid(),
                'member_type' => $this->clientType,
                'role' => 'admin'
            ]);
//            return 1;
//            Member::where('member_id',$value['id'])->where('member_type',$value['type'])->where('role','!=','admin')->delete();
//                if ()
            $member = array();
            if (isset($request->member)) {
                foreach ($request->member as $key => $value) {
                    Member::create([
                        'group_id' => $group->id,
                        'member_id' => $value['id'],
                        'uuid' => (string)Str::uuid(),
                        'member_type' => 'App\\Models\\' . Str::ucfirst($value['type']),
                        'role' => 'user'
                    ]);
//                Member::where('member_id',$value['id'])->where('member_type',$value['type'])->where('role','!=','admin')->delete();
                }
            }
            $groups=Group::where('id', $group->id)->with('members')->first();
//                        $groups['images']=['sasasa'];

        }
        return ($group) ? successResponse(true,CreateGroupResource::make($groups), 'made group successfully') :
            onFaile('Group not created successfully');
    }

    public function addMember($clientRole, AddMemberRequest $request, ChatService $chat)
    {
        $this->setInformation($clientRole);
        if (!$chat->checkClientExist($request))
            return $this->onFaile('member not found');

        $admin = Member::where('member_id', $this->clientId)->where('member_type', $this->clientType)->where('group_id', $request->group_id)->first();
        if ($admin) {
            if (($admin->role) != 'admin')
        return $this->onFaile('Only admin can add members to the group');
        }else {
            return $this->onFaile('You are not a member of this group');
        }
        if ($chat->checkMemberOnGroup($request))
            return $this->onFaile('The person is already a member');

        $member = $chat->addMemberUser($request);
        return ($member) ? $this->onSuccess($member) : $this->onFaile('error');
//        $member = array();
//        if (isset($request->member)) {
//            foreach ($request->member as $key => $value) {
//                Member::create([
//                    'group_id' => $request->group_id,
//                    'member_id' => $value['id'],
//                    'uuid' => (string)Str::uuid(),
//                    'member_type' => 'App\\Models\\' . Str::ucfirst($value['type']),
//                    'role' => 'user'
//                ]);
////                Member::where('member_id',$value['id'])->where('member_type',$value['type'])->where('role','!=','admin')->delete();
//            }
//        }
//        $member = Member::create([
//            'group_id' => Request()->group_id,
//            'member_id' => Request()->member_id,
//            'member_type' => Request()->member_type,
//            'member_type' => Request()->member_type,
//        ]);
//
//        return successResponse(true, $member, 'add member successfully');
    }

    public function getGroupMember($clientRole, ListGroupRequest $request)
    {

        $this->setInformation($clientRole);
        $uuid = $request->group_id;
        $getClient = Member::
        whereHas('group', function ($q) use ($uuid) {
            $q->where('uuid', $uuid);
        })
            ->where('member_id', $this->clientId)
            ->where('member_type', $this->clientType)
            ->first();

        if ($getClient) {
            if ($request->self == true) {
                $member = Member::with(['membres'=>function($q){
//                    $q->select('id');
                }]) ->whereHas('group', function ($q) use ($uuid) {
                    $q->where('uuid', $uuid);
                })->where('member_id', '!=', $this->clientId)
                    ->where('member_type', '!=', $this->clientType)->get();
            } else {
                $member = Member:: whereHas('group', function ($q) use ($uuid) {
                    $q->where('uuid', $uuid);
                })->get();
            }
        } else {
            return failedResponse('You are not a member of this group');
        }
        return ($member) ? successResponse(true, $member, 'send member successfully') : failedResponse('error');
    }

    public function countGroupMessageUnread()
    {
        DB::table('chatable_chats');
    }

    public function getGroupByUser($clientRole)
    {
        $this->setInformation($clientRole);

        $member = Member::query()->select('group_id')
            ->where('member_id', $this->clientId)
            ->where('member_type', $this->clientType)->get()->unique();

        $group = Group::where('id', $member)->get();

        return successResponse(true, $group, 'send successfully');
    }

    public function setChatable($clientRole)
    {
        //DB::table('chatable_chats')->
    }

    public function setInformation($clientRole)
    {
        $this->clientType = 'App\\Models\\' . Str::ucfirst($clientRole);
        $this->clientEntity = auth($clientRole)->user();
        $this->clientId = $this->clientEntity->id;
        $this->client = $this->clientType::find($this->clientId);
        return 1;
    }

    public function testAddGroup()
    {
        //test add group
        /*$fileName = Str::random(20);
dd($fileName);
        $data = [
            'address' => Request()->address,
            'type' => Request()->type,
            'message' => Request()->message,
        ];
        //$data = unset($data => ['message', '']);
        $group = Group::query()->create([
           'title' => "first group" ,
            'image' => Request()->image,
            'uuid' => Str::uuid()->toString(),
            'data' => json_encode($data)
        ]);

        return successResponse(true, $group->id, 'ok');*/

        //test get group
        /*$group = Group::where('id', 1)->first();
        return successResponse(true, $group, 'ok');*/

        //test add member
        /*$user = User::query()->where('id', 1)->first();
        $user->members()->create([
            'group_id' => 1,
            'role' => 'owner',
            'uuid' => Str::uuid()->toString()
        ]);
        return successResponse(true, null, 'ok');*/
        /**
         * @var Group $group
         */

        $group = Group::query()->where('id', 1)->first();

        /**
         * @var User $client
         */
        $client = User::query()->first();
        //$group->addMember($client, 'user');
        //dd('wedrfg');
        $data = [
            'title' => Request()->title,
            'image' => Request()->image
        ];
        $additionalData = [
            'address' => Request()->address,
            'type' => Request()->type,
        ];
        //$group->addGroup($client, $data, $additionalData);
        $client->sendChatMessage($group, ['message' => 'khob']);
        dd('edrfgh');
    }

    public function removeMember(Request $request,$groupId,$userId)
    {
        $check_admin=Member::query()
            ->where('group_id',$groupId)
            ->where('member_id',$request->user()->id)
            ->where('role',Member::ADMIN)
            ->first();
        
        if ($check_admin){
            $member=Member::query()
                ->where('group_id',$groupId)
                ->where('member_id',$userId)
                ->where('role',Member::USER)
                ->first();

            if (!$member){
                return  onFaile("کاربر مورد نظر یافت نشد");
            }
            $member->delete();
            return onSuccess([]);
        }
        else{
            return onFaile("شما دارای دسترسی ادمین نیستید");
        }
    }
}
