<?php

namespace App\Http\Controllers;

use App\Filter\FilterClass\Map\Completed;
use App\Filter\FilterClass\Map\InProgress;
use App\Filter\FilterClass\Map\Name;
use App\Filter\FilterClass\Map\Priority;
use App\Filter\FilterClass\Map\UpComing;
use App\Filter\FilterClass\project\ZipCode;
use App\Http\Resources\Map\ShowMapResource;
use App\Models\City;
use App\Models\Country;
use App\Models\Project;
use App\Models\State;
use App\Traits\ApiResponser;
use App\Traits\pipeline;
use Illuminate\Http\Request;

class MapController extends Controller
{
    use ApiResponser,pipeline;

    public function country(){
       $contry= Country::all();
        return ($contry) ?$this->onSuccess($contry):$this->onSuccess([]);
    }
    public function citys($id){
        $city=City::where('state_id',$id)->get();
        return ($city) ?$this->onSuccess($city):$this->onSuccess([]);
    }
    public function state($id){
        $state=  State::where('country_id',$id)->get();
        return ($state) ?$this->onSuccess($state):$this->onSuccess([]);
    }
    public function countryForApp(){
        $country= $this->pipeline(Country::query(),[Name::class]);
        return ($country) ?$this->onSuccess($country):$this->onSuccess([]);
    }
    public function cityForApp($id){
        $city=$this->pipeline(City::query()->where('state_id',$id),[Name::class]);
        return ($city) ?$this->onSuccess($city):$this->onSuccess([]);
    }
    public function stateForApp($id){
        $state=  $this->pipeline(State::query()->where('country_id',$id),[Name::class]);
        return ($state) ?$this->onSuccess($state):$this->onSuccess([]);

    }
    public function showAllProjectOnMap(){
//        return 1;
        $map = $this->pipelineWithoutPaginate(Project::query()->with('address')
            , [UpComing::class, InProgress::class, Completed::class,ZipCode::class,Priority::class]);

        return ($map) ? $this->onSuccess(ShowMapResource::collection($map)) : $this->onSuccess([]);
    }

}
