<?php

namespace App\Http\Resources\Project;

use App\Http\Resources\ShowDetailProjectResource;
use App\Models\GeneralContractor;
use App\Models\Owner;
use Illuminate\Http\Resources\Json\JsonResource;

class ShowOneProjectCommentsResource extends JsonResource
{
    /**
     * Transform the resource into an array.
     *
     * @param \Illuminate\Http\Request $request
     * @return array|\Illuminate\Contracts\Support\Arrayable|\JsonSerializable
     */
    public function toArray($request)
    {
//        return parent::toArray($request);
        $type = null;
        if ($this->profile_type == GeneralContractor::class)
            $type = 'general_contractor';
        if ($this->profile_type == Owner::class)
            $type = 'owner';

        return [
            'id' => $this->id,
            'text' => $this->text,
            'rate' => $this->rate,
            'client_name' => $this->client->name ?? "",
            'client_image' => $this->client->iamge ?? "",
            'profile_type' => $type,
            'client_image_project' => ShowDetailProjectResource::make(($this->client->images->first())),
//            'profile'=>$this->profile??"",
        ];
    }
}
