<?php

namespace App\Models;

use App\Models\Admin\Structure\Advertisement;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\Auth;

class Project extends Model
{
    use HasFactory;

    /*const TYPE = [
        'residential' => 1,
        'commercial' => 2
    ];

    const CONDITION = [
        'Completed' => 1,
        'In Progress' => 2,
        'Upcoming' => 3
    ];
    const PRIORITY = [
        'special' => 1,
        'normal' => 2
    ];*/
    protected $table = 'projects';
    protected $guarded = [
        'id'
    ];
    protected $casts=[
        'start_date'=>'datetime'
    ];
    protected $appends=['IsCreatoreUser','IsCreatoreCompany',];
//
    public function getIsCreatoreUserAttribute(){
//        $this->load('participants');
//        return get_class(Auth('user')->$this->participantsuser());
//        return $this->participants;
        if ($this->participants->first())
        return $this->participants->first()->participants_project_id ==Auth('user')->id() &&  $this->participants->first()->participants_project_type==get_class(Auth('user')->user());
    }
    public function getIsCreatoreCompanyAttribute(){
////        $this->load('participants');
////        return get_class(Auth('user')->user());
        if ($this->participants->first())
//            return ($this->participants->first());
            return $this->participants->first()->id==Auth('user')->id() &&  $this->participants->first()->participants_project_type==get_class(Auth('user')->user());
    }

    public function owner()
    {
        return $this->morphOne(Owner::class, 'ownerable');
    }

    public function address()
    {
        return $this->morphOne(Address::class, 'addressable', "addressable_type", "addressable_id");
    }

    public function images()
    {
        return $this->morphMany(Image::class, 'imageable');
    }
    public function imagesTake()
    {
        return $this->morphMany(Image::class, 'imageable')->limit(4);
    }

    public function generalContrcotore()
    {
        return $this->belongsTo(GeneralContractor::class, "general_contractor_id");
    }

    public function advertisement()
    {
        return $this->belongsTo(Advertisement::class);
    }

    public function projectable()
    {
        return $this->morphTo();
    }


    public function users()
    {
        return $this->morphedByMany(User::class, 'participant_projects');
    }

    public function cpmpanies()
    {
        return $this->morphedByMany(Company::class, 'participant_projects');
    }

    public function profileComments()
    {
        return $this->morphMany(Comment::class, 'profile');
    }
    public function participants()
    {
        return $this->hasMany(ParticipantsProject::class, 'project_id');
    }
    public function Comments(){
        return $this->hasMany(Comment::class, 'project_id');
    }
    public function generalContractor(){
        return $this->hasOne(GeneralContractor::class);
    }
    public function specialComments()
    {

        return $this->hasMany(SpecialComment::class);
    }



//    public function client()
//    {
//        return $this->morphTo();
//    }
//    public function keyWord(){
//        return $this->hasManyThrough(Keyword::class, ImageKeyword::class);
//}
}
