<?php

namespace App\Repositories;

use App\Models\Address;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class AddressRepository.
 */
class AddressRepository extends BaseRepository
{
    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return Address::class;
    }

    public function store($request, $type, $id)
    {
        return Address::create([
            'longitude' => isset($request['longitude']) ? $request['longitude'] : null,
            'latitude' => isset($request['latitude']) ? $request['latitude'] : null,
            'state' => isset($request['state']) ? $request['state'] : null,
            'country' => isset($request['country']) ? $request['country'] : null,
            'city' => isset($request['city']) ? $request['city'] : null,
            'zip_code' => isset($request['zip_code']) ? $request['zip_code'] : null,
            'main_text' => isset($request['main_text']) ? $request['main_text'] : null,
            'secondary_text' => isset($request['secondary_text']) ? $request['secondary_text'] : null,
            'addressable_type' => $type,
            'addressable_id' => $id
        ]);
    }

    public function update($request, $id)
    {
        return Address::where('id', $id)->update([
            'longitude' => isset($request['longitude']) ? $request['longitude'] : null,
            'latitude' => isset($request['latitude']) ? $request['latitude'] : null,
            'state' => isset($request['state']) ? $request['state'] : null,
            'country' => isset($request['country']) ? $request['country'] : null,
            'city' => isset($request['city']) ? $request['city'] : null,
            'zip_code' => isset($request['zip_code']) ? $request['zip_code'] : null,
            'main_text' => isset($request['main_text']) ? $request['main_text'] : null,
            'secondary_text' => isset($request['secondary_text']) ? $request['secondary_text'] : null,
        ]);
    }
}
