<?php

namespace App\Repositories;

use App\Models\Invoice;
use JasonGuru\LaravelMakeRepository\Repository\BaseRepository;

//use Your Model

/**
 * Class InvoiceRepository.
 */
class InvoiceRepository extends BaseRepository
{
    /**
     * @return string
     *  Return the model
     */
    public function model()
    {
        return Invoice::class;
    }

    public function store($data, $imageName, $referenceNumber, $client)
    {
//        return get_class($client);
        return Invoice::query()->create([
            'customer_name' => $data['customer_name'],
            'customer_email' => $data['customer_email'],
            'start_date' => $data['start_date'],
            'end_date' => $data['end_date'],
            'reference_number' => $referenceNumber,
            'invoiceable_type' => get_class($client),
            'invoiceable_id' => $client->id,
            'address' => $data['address'],
            'message' => $data['message'],
            'latitude' => $data['latitude'],
            'longitude' => $data['longitude'],
            'pdf_address' => $data['pdf_address'],
            'sub_total' => $data['sub_total'],
            'discount' => $data['discount'],
            'discount_type' => $data['discount'],
            'sale_tax' => $data['sale_tax'],
            'image' => $imageName,
            'total' => $data['total'],
            'term' => $data['term'],
            'deposit' => $data['deposit'],
            'status' => 'sent'

        ]);
    }

    public function show($id, $client)
    {
        return Invoice::query()->where('id', $id)
            ->where('invoiceable_type', get_class($client))
            ->where('invoiceable_id', $client->id)->with('lists')->first();
    }
    public function showList($client)
    {
        return Invoice::query()
            ->where('invoiceable_type', get_class($client))
            ->where('invoiceable_id', $client->id)
            ->select('id','customer_name','address','reference_number','total','message','pdf_address','status')

            //            ->with('lists')
            ->get();
    }

    public function deleteInvoice($id)
    {
        return Invoice::query()->where('id', $id)->delete();
    }


    public function addNote($id,$data)
    {
        return Invoice::query()->where('id', $id)->update([
            'status' => $data['status'],
            'report' => $data['report']
        ]);
    }
}
