<?php

use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\Admin\Authentication\LoginController;
use App\Http\Controllers\Admin\ClientController;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\GroupChatController;
use App\Http\Controllers\Admin\PermissionController;
use App\Http\Controllers\Admin\RoleController;
use App\Http\Controllers\Admin\Structure\FAQController;
use App\Http\Controllers\Admin\Structure\IndustryController;
use App\Http\Controllers\Admin\Structure\SpecialCommentsController;
use App\Http\Controllers\Admin\Structure\JobController;
use App\Http\Controllers\Admin\Structure\SettingController;
use Illuminate\Support\Facades\Route;

//FAQ
//Route::resource('faqs', FAQController::class);
Route::apiResource('faqs', FAQController::class);
Route::apiResource('jobs', JobController::class);
Route::apiResource('industry', IndustryController::class);

//setting
Route::get('setting',[SettingController::class, 'index']);
Route::post('setting',[SettingController::class, 'update']);

Route::apiResource('home-text',\App\Http\Controllers\Admin\Structure\HomeTextController::class);
Route::apiResource('team',\App\Http\Controllers\Admin\Structure\TeamController::class);
Route::apiResource('style',\App\Http\Controllers\Admin\Structure\StyleController::class);
Route::apiResource('estimate',\App\Http\Controllers\Admin\Structure\EstimateController::class);
Route::apiResource('invoice',\App\Http\Controllers\Admin\Structure\InvoiceController::class);
Route::apiResource('comments',\App\Http\Controllers\Admin\Structure\CommentsController::class);
Route::apiResource('special-comments',\App\Http\Controllers\Admin\Structure\SpecialCommentsController::class);
Route::apiResource('project',\App\Http\Controllers\Admin\Structure\ProjectController::class);

Route::get('dashboard',[DashboardController::class, 'index']);
Route::get('user/list',[DashboardController::class, 'userList']);
Route::get('company/list',[DashboardController::class, 'companyList']);
Route::post('company/status',[ClientController::class, 'changeStatusCompany']);
Route::post('company',[ClientController::class, 'CreateCompany']);
Route::post('user/status',[ClientController::class, 'changeStatusUser']);
Route::post('/login-admin',[LoginController::class, 'login']);
Route::post('/faqs',[FAQController::class, 'store']);

Route::get('list',[AdminController::class, 'list']);
//get methods
Route::get('admins',[AdminController::class,'allAdmins'])->name('all.admins');
Route::get('admin/{adminId}',[AdminController::class,'showAdmin'])->name('show.admin');
//post methods
Route::post('admin',[AdminController::class,'createAdmin'])->name('create.admin');
//put methods
Route::put('admin/{adminId}',[AdminController::class,'updateAdmin'])->name('update.admin');
//delete methods
Route::delete('admin/{adminId}',[AdminController::class,'deleteAdmin'])->name('delete.admin');

Route::get('permissions',[PermissionController::class,'allPermissions'])->name('all.permissions')->middleware(['auth:sanctum','isAdmin']);

Route::get('roles',[RoleController::class,'allRole'])->name('all.roles');
Route::get('role/{roleId}',[RoleController::class,'showRole'])->name('show.role');


//post methods
Route::post('role',[RoleController::class,'createRole'])->name('create.role');
//put methods
Route::put('role/{roleId}',[RoleController::class,'updateRole'])->name('update.role');
Route::put('special-comments/{commentId}/status',[SpecialCommentsController::class,'changeStatus'])->name('status.special-comment');

//delete methods
Route::delete('role/{roleId}',[RoleController::class,'deleteRole'])->name('delete.role');

Route::delete('company/{name}',[ClientController::class, 'deleteCompany']);
Route::delete('user/{name}',[ClientController::class, 'deleteUser']);
Route::put('users/{id}',[ClientController::class,'updateUser']);
Route::post('users/',[ClientController::class,'createUser']);
Route::post('company/{id}',[ClientController::class,'updateCompany']);
Route::post('add/member',[GroupChatController::class,'addMember']);
Route::delete('member/{groupId}/{memberId}',[GroupChatController::class, 'deleteMember']);
Route::delete('group/{groupId}',[GroupChatController::class, 'deleteGroup']);
Route::get('group-chats',[GroupChatController::class,'groupChatList']);
Route::get('group/{groupId}/members',[GroupChatController::class, 'groupMembers']);
